<?
require "../inc/config.inc.php";
require "../../../adm/lib/setup.php";

require "community_user.class.php";
require "community.class.php";
//require "../../".GLOBAL_PRISCILLA_PACKAGES_PATH."/datahandler/DataHandler.php";
//require "../../".GLOBAL_PRISCILLA_PACKAGES_PATH."/datahandler/childs/session.php";

// se non esiste inizializzo tramite singleton oggetto di sessione
//require "../../../adm/lib/priscilla_session_init.inc.php";

////////////////////////////////// funzioni di supporto

function nlSendMail($from, $to, $subject, $message) {
global $smtpserver, $smtpuser,  $smtprealm, $smtppassw;


    if (!function_exists("GetMXRR")) {
	$_NAMESERVERS = array();
	require("../../../packages/smtp/getmxrr.php");
    }
    require ("../../../packages/smtp/smtp.php");


    $smtp = new smtp_class;
    $smtp->host_name = $smtpserver; /* relay SMTP server address */
    $smtp->localhost = "localhost";         /* this computer address */
    $smtp->direct_delivery = 0;     /* Set to 1 to deliver directly to the recepient SMTP server */
    $smtp->debug = 0;               /* Set to 1 to output the communication with the SMTP server */
    $smtp->user = $smtpuser;        /* Set to the user name if the server requires authetication */
    $smtp->realm = $smtprealm;      /* Set to the authetication realm, usually the authentication user e-mail domain */
    $smtp->password = $smtppassw;   /* Set to the authetication password */


    $headers = array(
	"From: $from",
	"To: $to",
	"Subject: $subject",
	"X-Mailer: PriscillaCommunity",
	"Date: " . strftime("%a, %d %b %Y %H:%M:%S %Z")
    );

    if ($smtp->SendMessage(
	$from,
	array($to),
	$headers,
	$message
    ))
	return 1;
    else return 0;
}


function comeback($idp, $message) {
global $PRISCILLA_SESSION;

    $PRISCILLA_SESSION->add('community_reg_msg', $message);
    header("Location: ../../../index.php?id=$idp");
    die();
}

function generateCookie ($item1, $item2) {
    srand ((float) microtime() * 10000000);
    $random_middle = rand();
    $mypreid = $item1 . $random_middle . $item2;

return md5($mypreid);
}

function get_community_name_from_id($id, $connh) {

    $community_name = '';
    $dbquery = "SELECT nome FROM community WHERE id = '$id'";
    $rs = $connh->Execute($dbquery);
    if ($rs && $rs->RecordCount())
        $community_name = $rs->fields('nome');

return $community_name;
}

function is_valid_username_password ($up) {

    if (!(ereg("^([[:alnum:]]{6,16})$", $up)))
        return false;
    else return true;
}

////////////////////////////////// fine funzioni di supporto


$usertable = $PRISCILLA_SESSION->getvalue('usertable');
if ($usertable[lingua] == '') $usertable[lingua] = $lang;

require_once "../lang/$usertable[lingua]/community.diz";

$community_user_table = "community_user_content";
$community_table = "community";


if (isset($_POST['id_community']))
    $id_community = $_POST['id_community'];
else
    $id_community = $_GET['nlid'];


// si va a vedere che tipo di comunity e' questa (classica o datatonic_community)

$is_a_datatonic_community = 0;
$dbquery = "SELECT datatonic_community FROM $community_table WHERE id = '" . $id_community . "'";
$rstype = $connh->Execute($dbquery);
if ($rstype && $rstype->RecordCount() == 1)
    $is_a_datatonic_community = $rstype->fields('datatonic_community');


 // email del mittente e' l'email del proprietario della community
$dbquery = "SELECT proprietario FROM $community_table WHERE id = '" . $id_community . "' LIMIT 1";
$rsc1 = $connh->Execute($dbquery);

if ($rsc1 && $rsc1->RecordCount()) {

    $dbquery = "SELECT email FROM user WHERE username = '" . $rsc1->fields('proprietario') . "' LIMIT 1";
    $rsc2 = $connh->Execute($dbquery);

    if ($rsc2 && $rsc2->RecordCount())
        $from = $rsc2->fields('email');
}

// se' e' una datatonic community si prendono i dati per l'accesso ai servizi datatonic
if ($is_a_datatonic_community) {

    $dbquery = "SELECT * FROM datatonic_conf WHERE id = '" . $is_a_datatonic_community . "'";
    $rsrow = $connh->Execute($dbquery);

    if ($rsrow && $rsrow->RecordCount()) {
        $row = $rsrow->fields;
        $datatonic_serverpath = $row['serverpath'];
        $datatonic_username = $row['username'];
        $datatonic_password = $row['password'];
    }
}


//
// subito vediamo se e' una richiesta di conferma //////////////////////////////////////////////////////////////////
//
if (isset($_GET['pid']) && is_numeric($_GET['pid']) && isset($_GET['email']) && isset($_GET['cookie']) && isset($_GET['nlid']) && is_numeric($_GET['nlid'])) {

    $activationcookie = $_GET['cookie'];
    $community_name = get_community_name_from_id($_GET['nlid'], $connh);

    // prima si vede se siamo in attesa di attivazione
    $dbquery = "SELECT * FROM " . $community_user_table .
	    " WHERE id_community = '$_GET[nlid]' AND email = '$_GET[email]' AND activationcookie = '$activationcookie' AND isactivestatus = 'no'";

    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

    if ($rowrs->RecordCount() == 1) {

            $c_user_data = $rowrs->fields;

            $adesso = time();
            $c_user_data['isactivestatus'] = 'yes';
            $c_user_data['ip_address'] = $_SERVER['REMOTE_ADDR'];

            if ($is_a_datatonic_community) {
                require_once "../../../adm/lib/nusoap.php";
    
                $client = new soapclient($datatonic_serverpath . "datatonic_user_add.php");
                if ($fault = $client->getError())
                    comeback($_GET['pid'], "error 1: " . $fault);
    
                $param['datatonic_username'] = $datatonic_username;
                $param['datatonic_password'] = $datatonic_password;
                $param['s_userdata'] = serialize($c_user_data);
        
                $s_result = $client->call("datatonic_user_add", $param);
                if ($fault = $client->getError())
                    comeback($_GET['pid'], "error 2: " . $fault);
            }

            $dbquery = "UPDATE " . $community_user_table .
                " SET isactivestatus = 'yes', time_activation = NOW() WHERE id = '" . $rowrs->fields('id') . "' LIMIT 1";

            $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());


            // indirizzo per la rimozione
            $server_path = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
            $link = $server_path . "?pid=" . $_GET['pid'] . "&nlid=" . $_GET['nlid'] . "&remove=" . $_GET['email'] . "&cookie=" . $_GET['cookie'];

            $subject = sprintf(COMMUNITY_CONFIRM_SUBJECT, $community_name);
            $message = sprintf(COMMUNITY_MAILCONFIRM_MESSAGE . "\n\n" . $link, $community_name);
                

            if (nlSendMail($from, $_GET['email'], $subject, $message))
                comeback($_GET['pid'], COMMUNITY_ACTIVATION_OK . " \"$_GET[email]\"");
            else
                comeback($_GET['pid'], COMMUNITY_ACTIVATION_ALMOSTOK); 
    }
    else comeback($_GET['pid'], COMMUNITY_ERROR_ACTIVATION . " \"$_GET[email]\"");
}


//
//  richiesta di rimozione ////////////////////////////////////////////////////////////////////
//
if (isset($_GET['pid']) && is_numeric($_GET['pid']) && isset($_GET['remove']) && isset($_GET['cookie'] ) && isset($_GET['nlid']) && is_numeric($_GET['nlid'])) {


    $activationcookie = $_GET['cookie'];
    $community_name = get_community_name_from_id($_GET['nlid'], $connh);

    $dbquery =
	    "SELECT id FROM " . $community_user_table . " WHERE id_community = '$_GET[nlid]' AND email = '$_GET[remove]' AND activationcookie = '$activationcookie' AND isactivestatus = 'yes' LIMIT 1";


    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

    if ($rowrs && $rowrs->RecordCount()) {

        if ($is_a_datatonic_community) {
            require_once "../../../adm/lib/nusoap.php";
    
            $client = new soapclient($datatonic_serverpath . "datatonic_user_remove.php");
            if ($fault = $client->getError())
                comeback($_GET['pid'], "error 1: " . $fault);
    
            $c_user_data['email'] = $_GET['remove'];
            $c_user_data['ip_address'] = $_SERVER['REMOTE_ADDR'];
    
            $param['datatonic_username'] = $datatonic_username;
            $param['datatonic_password'] = $datatonic_password;
            $param['s_userdata'] = serialize($c_user_data);
        
            $s_result = $client->call("datatonic_user_remove", $param);
                if ($fault = $client->getError())
                    comeback($_GET['pid'], "error 2: " . $fault);
         }

        $dbquery =
	        "UPDATE " . $community_user_table .
            " SET isactivestatus = 'no', time_remove = NOW()" .
            " WHERE id_community = '$_GET[nlid]' AND email = '$_GET[remove]' AND activationcookie = '$activationcookie' AND isactivestatus = 'yes' LIMIT 1";

        $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());
    
        if ($connh->Affected_Rows() == 1) {

	        $subject = sprintf(COMMUNITY_REMOVE_SUBJECT, $community_name);
	        $message = sprintf(COMMUNITY_REMOVE_MESSAGE . "\n\n" . $_GET['remove'], $community_name);
	        nlSendMail($from, $_GET['remove'], $subject, $message);
            comeback($_GET['pid'], COMMUNITY_REMOVE_OK . " \"$_GET[remove]\"");
        }
        else comeback($_GET['pid'], COMMUNITY_ERROR_REMOVE . " \"$_GET[remove]\"");	
 

    }
    else comeback($_GET['pid'], COMMUNITY_ERROR_REMOVE . " \"$_GET[remove]\"");	

}
////////////////////////////////////////////////////////////////////////////////////////////////


if (!isset($_POST['idp'])) {
    die("<center><h2>" . "Input param error" . "</h2></center>");
}

$error = false;

// si cercano campi data
$dateviste = array();
foreach ($_POST as $key=>$val)
{
    if (strstr($key, '_dated') || strstr($key, '_datem') || strstr($key, '_datey')) {
        $datefield = substr($key, 0, -6);
        if (in_array($datefield, $dateviste)) continue;
        $_POST[$datefield] = $_POST[$datefield.'_datey'].'-'.$_POST[$datefield.'_datem'].'-'.$_POST[$datefield.'_dated'];
        $dateviste[] = $datefield;
    }
}


// array che andrà a finire in sessione per ricordare gli input dell'utente
$filled = array();
// controllo dei campi e opzioni
foreach ($_POST as $key=>$val) //per ogni valore che mi arriva
{
    if ($key != 'idp' && $key != 'community_existent' && $key != 'password2') {
        if ($key == 'username' || $key == 'password' || $key == 'email' || $key == 'id_community') {
            if ($val != '') {
                if ($key == 'username')
                    $filled[$key] = $val;
                $param[$key] = $val;
            }
            else {
                if ($PRISCILLA_SESSION->exists($key)) $PRISCILLA_SESSION->remove($key);
                $PRISCILLA_SESSION->add('community_reg_msg', community_reg_fields_obb);
                $error = true;
            }
        }
        else
        {
            // controllo la tabella relazione per il campo $key
            $query = "SELECT * FROM community_userFields WHERE nome='$key'";
            $rs = $connh->Execute($query) or die("ERR: $query<br />".$rs->ErrorMsg());
            if ($rs->RecordCount() > 0)
            {
                $filled[$key] = $val;
                /*$query = "SELECT $key FROM community_user_content LIMIT 1,0";
                $rsc = $connh->Execute($query) or die("ERR: $query<br />".$rs->ErrorMsg());
                $field = $rsc->FetchField(0);*/

                // se era obbligatorio e non e' stato riempito
                if ($rs->fields('obbligatorio') == 'true' && $val == '')
                {
                    if ($PRISCILLA_SESSION->exists($key)) $PRISCILLA_SESSION->remove($key);
                    $PRISCILLA_SESSION->add('community_reg_msg', community_reg_fields_obb);
                    $error = true;
                }

                if (!$error) $param[$key] = addslashes($val);
            }
        }
        
        $regmail_fields .= strtoupper($key).": ".$val."\n";
    }
}

$PRISCILLA_SESSION->add('community_filled', $filled);

// inserimento o aggiornamento dell'utente
if ($error != true)
{
    $query = "SELECT * FROM community_user_content WHERE username='$_POST[username]'";
    $rs = $connh->Execute($query);
    if ($rs->RecordCount() > 0) // se l'utente esiste gia'
    {
        if ($_POST[community_exist] == 'ok' && !$is_a_datatonic_community) // dichiara di essersi gia' iscritto ad una comunity del sito
        {
            $query = "SELECT * FROM community_user_content WHERE username='$_POST[username]' and password='$_POST[password]'";
            $rs1 = $connh->Execute($query);
            if ($rs1->RecordCount() != 1) $PRISCILLA_SESSION->add('community_reg_msg', community_reg_existent_false);
            else
            {
                if (in_array($_POST[id_community], explode(',',$rs1->fields('id_community'))))
                    $PRISCILLA_SESSION->add('community_reg_msg', community_reg_existent);
                else
                {
                    foreach ($_POST as $key=>$val) if ($key != 'idp') $PRISCILLA_SESSION->remove($key);
                    $PRISCILLA_SESSION->add('community_reg_msg', community_reg_update);
                    $param[id_community] = $_POST[id_community].','.$rs1->fields('id_community');
                    $rs = $connh->Execute("SELECT * FROM community_user_content WHERE username='$_POST[username]'");
                    $query = $connh->getUpdateSQL($rs, $param, $magicq=true);
                    $rs = $connh->Execute($query);
                }
            }
        }
        else {
            $PRISCILLA_SESSION->add('community_reg_msg', community_reg_username_err.$_POST[username]);
            $error = true;
        }
    }
    else
    {
        foreach ($_POST as $key=>$val) if ($key != 'idp') $PRISCILLA_SESSION->remove($key);
        $rs = $connh->Execute("SELECT * FROM community_user_content WHERE id='-1'");

        // un controllo sulla bonta' della password e username
        if (!is_valid_username_password($param['username']) || !is_valid_username_password($param['password']))
            comeback($_POST['idp'], COMMUNITY_ERROR_USERNAME_PASSWORD);

        $name = $param['nome'] . " " . $param['cognome'];
        $activationcookie = generateCookie($param['email'], $name);
        $param['activationcookie'] = $activationcookie;
        $param['isactivestatus'] = 'no';
        $param['time_request'] = time();

        $community_name = get_community_name_from_id($_POST['id_community'], $connh);

        $dbquery = "SELECT id FROM " . $community_user_table . " WHERE LOWER(email) = '" . strtolower($param['email']) . "' AND id_community = '$_POST[id_community]' LIMIT 1";
        $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());

        if ($rowrs->RecordCount() > 0)
            comeback($_POST['idp'], COMMUNITY_ERROR_SUBSCRIPTION . " \"" . $param[email] . "\"");

        // indirizzo per la conferma della registrazione
        $server_path = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
        $link = $server_path . "?pid=" . $_POST['idp'] . "&nlid=" . $_POST['id_community'] . "&email=" . $param['email'] . "&cookie=$activationcookie";

        $subject = sprintf(COMMUNITY_SUBSCRIPTION_SUBJECT, $community_name);		    
        $message = sprintf(COMMUNITY_MAIL_MESSAGE . "\n\n" . $link, $community_name);
		
        $query = $connh->getInsertSQL($rs, $param, $magicq=true);

        $rs = $connh->Execute($query) or die($connh->ErrorMsg());

        // invio dell'email
        if (nlSendMail($from, $param['email'], $subject, $message)) {
            $PRISCILLA_SESSION->remove('community_filled');
            comeback($_POST['idp'], COMMUNITY_SUBSCRIPTION_OK . " " . $param['email']);
        }
        else
            comeback($_POST['idp'], COMMUNITY_ERROR_SUBSCRIPTION . "  " . $param['email'] . ".");
    }
   

    // se c'e' un errore non si invia un'email al proprietario della community
    if ($error != true) {
    
        $communityObj = new community ($connh, $_POST[id_community]);
        if ($communityObj->sendmailatreg == 1 && !$is_a_datatonic_community)
        {
            $urs = $connh->Execute("SELECT email FROM user WHERE username='".$communityObj->proprietario."'") or die($connh->ErrorMsg());
            if ($urs->fields('email') != '')
            {
                $regmail_msg = community_regmail_head."\n\n".$regmail_fields."\n";
                if (!function_exists("GetMXRR")) {
                    $_NAMESERVERS = array();
                    require("../../../packages/smtp/getmxrr.php");
                }
                require ("../../../packages/smtp/smtp.php");
            
                $smtp = new smtp_class;
                $smtp->host_name = $smtpserver; /* relay SMTP server address */
                $smtp->localhost = "localhost";         /* this computer address */
                $smtp->direct_delivery = 0;     /* Set to 1 to deliver directly to the recepient SMTP server */
                $smtp->debug = 0;               /* Set to 1 to output the communication with the SMTP server */
                $smtp->user = $smtpuser;        /* Set to the user name if the server requires authetication */
                $smtp->realm = $smtprealm;      /* Set to the authetication realm, usually the authentication user e-mail domain */
                $smtp->password = $smtppassw;   /* Set to the authetication password */
        
                $headers = array(
                "From: ".$urs->fields('email'),
                "To: ".$urs->fields('email'),
                "Subject: ".community_regmail_subj.$communityObj->nome,
                "X-Mailer: PRISCILLA CMS",
                "Date: " . strftime("%a, %d %b %Y %H:%M:%S %Z")
                );
                
                $smtp->SendMessage($urs->fields('email'), array($urs->fields('email')), $headers, $regmail_msg);
            }
        }
    }

}


header("Location: ../../../index.php?id=$_POST[idp]");

?>
