<?php
// $Id: a_swf.php,v 1.4 2010/07/08 10:21:40 riccardo Exp $
require_once "../../../adm/lib/setup.php";
require PRISCILLA_LOCAL_PATH . "adm/lib/test_auth.php";
require PRISCILLA_LOCAL_PATH . "modules/core/lib/attach_config.inc.php";

require_once PRISCILLA_LOCAL_PATH . "tools/lang/$lang/dialog.diz";
require_once PRISCILLA_LOCAL_PATH . "tools/lang/$lang/error.diz";

define ("SWF_MAX_NAME_LENGTH", 251);

// estraggo i dati dell'utente (per personalizzazioni)
    $usertable = $PRISCILLA_SESSION->getvalue('usertable');
    
    if ($usertable[livello] > 2)
        die("Authentication failed");
        
$skin = $PRISCILLA_SESSION->getvalue('sk');
$lang = $PRISCILLA_SESSION->getvalue('lingua');

$tipoallegato = T_FLASH;

// massima dimensione per questo tipo di allegato
$maxfsize = $attach_size[$tipoallegato];
// estensioni consentite
$attachext = $attach_extension[$tipoallegato];

$maxsize_mb = round($attach_size[$tipoallegato] / (1024 * 1024));

$predir = PRISCILLA_LOCAL_PATH."attach/".$_COOKIE['login']."/$tipoallegato";

if (!is_dir($predir))
    if (!mkdir($predir, 0777))
        die("Could not create '$predir' directory");


if (isset($upswffile)) 
{
    $upswffile_size = $_FILES["upswffile"]["size"];
    $upswffile_name = $_FILES["upswffile"]["name"];


    if ($upswffile_size == 0 || $upswffile_size > $maxfsize)
        $upmsg = dialog_gen_size . ": " . dialog_upl_nok;
    else {

        $upfilename = strtolower($upswffile_name);

        if (strstr($upfilename, '.')) {
            $l = strlen($upfilename);
            $realext = "";
            for ($q = $l - 1; $q > -1; $q--) {
                if ($upfilename{$q} == '.') {
                    $prename = substr($upfilename, 0, $q);
                    $upfilename = str_replace(".", "_", $prename) . "." . $realext;
                    break;
                }
                else $realext = $upfilename{$q} . $realext;
            }

        }

        $upfilename = ereg_replace('[/\\]', '_', $upfilename);

        if (!ereg('^\.', $upfilename) && ereg($attachext, $upfilename) && !ereg($attachext_denied, $upfilename) && strlen($upfilename) < SWF_MAX_NAME_LENGTH)
        {
            // se il file c'&Egrave; gi&agrave; ---> rinomina automatica (non si stressa l'utente!)
            if (file_exists($predir . "/" . $upfilename))
                $upfilename = time() . "_" . $upfilename;   

            if (copy("$upswffile", $predir . "/" . $upfilename))
                $upmsg=dialog_upl_ok;
            else $upmsg=dialog_upl_nok; 
        }
        else {
            $upmsg=dialog_upl_nosup;
            if (strlen($upfilename) >= SWF_MAX_NAME_LENGTH)
                $upmsg .= " [NAME LENGTH ERROR]";
        }
    }
}

if ($action=='save_indb')
{
    $dbquery="SELECT * FROM flash WHERE id='$id'";
    $rowrs = $connh->Execute($dbquery);
    if (($rowrs->RowCount()) != 0)
    {
        if (isset($id) && is_numeric($id)) {
            $dbquery="UPDATE flash SET quality='$quality', width='$width', height='$height', path='$filename', title='$title' WHERE id = '$id'";
            $rowrs = $connh->Execute($dbquery);
            $upmsg=dialog_upl_mod;
        }
    }
    else
    {
        $dbquery="INSERT INTO flash (quality, width, height, path, title, id_user) VALUES ('$quality','$width','$height','$filename', '$title', '".$_COOKIE['login']."')";
        $rowrs = $connh->Execute($dbquery);
        $upmsg=dialog_upl_save;
    }
    $action='';
}

if ($action=='modifica')
{

    $dbquery="SELECT * FROM flash WHERE id='$id'";
    $rowrs = $connh->Execute($dbquery);
    $mrow = $rowrs->fields; 
}

if($action=='elimina'){

    // prendiamo prima le info che c'interessano
    $dbquery = "SELECT * FROM flash WHERE id = '$id'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
    
    if (! $rowrs->RecordCount())
        die("Error: file (id=$id_allegato) not found!");
    else {
        $row = $rowrs->fields;      
        $filename = $predir . "/" . $row[path];
    }
                
    // cancellazione allegato in tabella...
    $dbquery = "DELETE FROM flash WHERE id = '$id'";
    $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());    
    // ... e da filesystem
    unlink($filename);
    $action='';
}
?>
<?php
    include PRISCILLA_LOCAL_PATH."adm/include/html_head.inc.php";
    print "</a><title>".dialog_vid_tit."</title>";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRISCILLA_SERVER_PATH . "adm/skin/$skin/default.css\">";
    print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"".PRISCILLA_SERVER_PATH."adm/skin/ie6.css\" />
		<![endif]-->";
print "</head>";
    include PRISCILLA_LOCAL_PATH . "adm/skin/$skin/body.inc";
    include PRISCILLA_LOCAL_PATH . "adm/include/head_popup.inc.php";
?>
<table align="center" class="table_border" width="<? include PRISCILLA_LOCAL_PATH."adm/include/dim_all.inc.php"; ?>" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th class="table_tit"><? print dialog_swf_tt_ins; ?></th>
</tr><tr>
    <td class="table_sez"><? print dialog_att_maxsize . " " . $maxsize_mb; ?></td>
</tr><tr>
<form enctype="multipart/form-data" method="post" action="a_swf.php">
    <td align="center" class="insert_voice"><input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $maxfsize; ?>">
    <input class="insert_area" type="file" name="upswffile" size="61" /></td>
</tr><tr>
    <td align="center" class="button_out"><input type="submit" name="action" class="button_in awesome" value="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<? print dialog_but_send; ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"></td>
</form>
</tr>
<?php if($upmsg) echo "<tr><td align=\"center\" colspan=\"4\" class=\"insert_message\"><strong>$upmsg</strong></td></tr>"; ?>
</table><br />
<?php
if ($upmsg == dialog_upl_ok or $mrow)
{
echo "<table align=\"center\" class=\"table_border\" width=\"95%\" cellpadding=\"3\" cellspacing=\"1\" border=\"0\">
<tr>
    <th colspan=\"4\" class=\"table_tit\">".dialog_swf_tt_set.strtoupper($upfilename)."</th>
</tr><tr>
    <td align=\"center\" colspan=\"4\" class=\"insert_voice\">
    <embed src=\"".PRISCILLA_SERVER_PATH."attach/".$mrow[id_user]."/flash/".$mrow[path]."\" 
    width=\"$mrow[width]\"
    height=\"$mrow[height]\"
    allowscriptaccess=\"always\"
    allowfullscreen=\"true\"
    wmode=\"transparent\"
    /></td>
</tr><form method=\"post\"><input type=\"hidden\" name=\"action\" value=\"save_indb\"><input type=\"hidden\" name=\"filename\" value=\"$upfilename$mrow[path]\"><tr>
    <th class=\"table_sez\">".dialog_gen_quality."</td>
    <th class=\"table_sez\">".dialog_gen_width."</td>
    <th class=\"table_sez\">".dialog_gen_height."</td>
</tr><tr>
    <td align=\"center\" class=\"insert_voice\"><select name=\"quality\">
    <option value=\"$mrow[quality]\">$mrow[quality]
    <option value=\"high\">high
    <option value=\"medium\">medium
    <option value=\"low\">low
    </select></td>
    <td align=\"center\" class=\"insert_voice\"><input type=\"text\" name=\"width\" value=\"$mrow[width]\"></td>
    <td align=\"center\" class=\"insert_voice\"><input type=\"text\" name=\"height\" value=\"$mrow[height]\"></td>
</tr><tr>
    <th class=\"table_sez\">".dialog_meta_desc."</td>
    <td colspan=\"2\" class=\"insert_voice\"><input type=\"text\" name=\"title\" value=\"$mrow[title]\" style=\"width:100%\"></td>
</tr><tr>
    <td align=\"center\" colspan=\"3\" class=\"button_out\"><input type=\"submit\" name=\"submit\" value=\"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".dialog_gen_save."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\" class=\"button_in awesome\"></td>
</tr></form>
</table><br />";
}
?>

<?php


$condizione = "WHERE id_user = '".$_COOKIE['login']."'";
$dbquery = "SELECT COUNT(id) as nrow FROM flash $condizione ORDER BY id";
$rowrs = $connh->Execute($dbquery);
$nrow_row = $rowrs->fields;
$nrow = $nrow_row[nrow];

?>


<table align="center" class="table_border" width="<? include PRISCILLA_LOCAL_PATH."adm/include/dim_all.inc.php"; ?>" cellpadding="3" cellspacing="1" border="0">

<tr>
    <th colspan="5" class="table_tit"><? print dialog_all_tt_ins_list; ?></th>
    <th colspan="2" class="table_tit">
        <?php print dialog_img_panel_tot." $nrow";
        if ($nrow)
            echo "&nbsp;|&nbsp;<a class=\"tree_mylink\" href=\"modules/core/lib/att_down.php?tipoallegato=$tipoallegato\">".dialog_but_attach_save."</a>";
        ?>
    </th>
</tr><tr>
    <th class="table_sez"><span class="insert_message"><? print dialog_gen_id; ?></span></th>
    <th class="table_sez"><? print dialog_gen_name; ?></th>
    <th class="table_sez"><? print dialog_gen_width; ?></th>
    <th class="table_sez"><? print dialog_gen_height; ?></th>
    <th class="table_sez"><? print dialog_gen_quality; ?></th>
    <th colspan="2" class="table_sez"><? print dialog_gen_action; ?></th>
</tr>
<?php 
$dbquery="SELECT * FROM flash WHERE id_user = '".$_COOKIE['login']."'";
$rowrs = $connh->Execute($dbquery);
while (!$rowrs->EOF)
{
    $row = $rowrs->fields;
    echo"
    <tr>
       <td align=center class=\"table_id\"><strong>$row[id]</strong></td>
       <td align=\"center\" class=\"insert_voice\">$row[path]</td>
       <td align=\"center\" class=\"insert_voice\">$row[width]</td>
       <td align=\"center\" class=\"insert_voice\">$row[height]</td>
        <td align=\"center\" class=\"insert_voice\">$row[quality]</td>
        <td align=\"center\" class=\"table_link\"><a href=\"a_swf.php?id=$row[id]&action=modifica\">".dialog_gen_edit."</a></td>
        <td align=\"center\" class=\"table_link\"><a href=\"a_swf.php?id=$row[id]&action=elimina\">".dialog_gen_del."</a></td>
    </tr>";
    $rowrs->MoveNext();
}
?></table><br />
<?
    include PRISCILLA_LOCAL_PATH.'adm/include/closewin.js';
?>
<?php
    include PRISCILLA_LOCAL_PATH."adm/include/menu_allegati.inc.php";
    include PRISCILLA_LOCAL_PATH."adm/include/about_root.inc.php";
?>
</body></html>
