<?php

// $Id: attach_config.inc.php,v 1.2 2009/01/30 09:17:22 antonio Exp $
// carica le impostazioni degli allegati e costruisce array size ed extension

define ("TABLE_ALLEGATI_CONFIG", "allegati_config");
define ("ATTACH_MAX_SIZE", 16);	// dimensione massima in MB per un allegato in upload

define('T_DOCS', 'docs');
define('T_ARCHIVE', 'archive');
define('T_AUDIO', 'audio');
define('T_VIDEO', 'video');
define('T_FLASH', 'flash');
define('T_FOTO', 'foto');


$attach_list = array (T_DOCS, T_ARCHIVE, T_AUDIO, T_VIDEO, T_FLASH, T_FOTO);

// estensioni da rifiutare
$attachext_denied = '\.php$|\.phtml$|\.php3$|\.pl$';

$default_attach_extension = array (
    T_DOCS =>'.doc|.txt|.rtf|.pdf|.ps|.abw|.sxw|.xls|.sxi|.sxc|.ppt',
    T_ARCHIVE => '.zip|.tar|.gz|.tgz|.bz|.bz2|.arj',
    T_AUDIO => '.mp3|.wav|.mid|.ogg|.au',
    T_VIDEO => '.mpeg|.mp4|.mpg|.avi|.qt|.mov|.wmv',
    T_FLASH => '.swf',
    T_FOTO => '.jpg|.jpeg|.png|.gif|.ico'
);

$default_attach_size = array (
    T_DOCS =>  1048576,
    T_ARCHIVE => 5242880,
    T_AUDIO => 3145728,
    T_VIDEO => 8388608,
    T_FLASH => 3145728,
    T_FOTO  => 262144
);

// vediamo se esiste la tabella allegti. se manca la si crea
$tbl_array = $connh->MetaTables();

if (!in_array(TABLE_ALLEGATI_CONFIG, $tbl_array)) {
        $dbquery = "CREATE TABLE `" . TABLE_ALLEGATI_CONFIG . "` (
        `id` int(11) NOT NULL auto_increment,
        `aname` varchar(16) NOT NULL default '',
        `extension` varchar(254) NOT NULL default '',
        `maxsize` int(11) NOT NULL default '0',
        PRIMARY KEY ( `id` )
        ) TYPE = MYISAM ;";

        $rs = $connh->Execute($dbquery) or die($dbquery. "<br />" . $connh->ErrorMsg());
}


// si vanno a prendere le entrate dalla tabella di configurazione

$dbquery = "SELECT * FROM " . TABLE_ALLEGATI_CONFIG;
$rowrs = $connh->Execute($dbquery) or die($dbquery. "<br />" . $connh->ErrorMsg());

if ($rowrs->RecordCount() <= 0) {

// se non ci sono entrate si inseriscono i defaults

    foreach ($attach_list as $currtype) {
	$dbquery = "INSERT INTO " . TABLE_ALLEGATI_CONFIG .
	    " (aname, extension, maxsize) VALUES ('" .
	    $currtype . "', '" . $default_attach_extension[$currtype] . "', '" . $default_attach_size[$currtype] . "')";

	 $connh->Execute($dbquery) or die($dbquery. "<br />" . $connh->ErrorMsg());
    }


    $dbquery = "SELECT * FROM " . TABLE_ALLEGATI_CONFIG;
    $rowrs = $connh->Execute($dbquery) or die($dbquery. "<br />" . $connh->ErrorMsg());

}

// si costruiscono gli array con le impostazioni da database


    $attach_size = array();
    $attach_extension = array();

    while (!$rowrs->EOF) {

	$row = $rowrs->fields;
	$attach_size[$row['aname']] = $row['maxsize'];
	$attach_extension_pulite[$row['aname']] = str_replace('|', '', $row['extension']);
	$attach_extension[$row['aname']] = str_replace('|', '$|', str_replace(".", "\.", $row['extension'])) . '$';

	$rowrs->MoveNext();
    } // while

// a questo punto gli array sono disponibili

?>
