<?
// $Id: contentadmin_linear.inc.php,v 1.1.1.1 2008/11/06 10:53:10 antonio Exp $

function check_content_usage($id, $tbname, $connh)
{
    $query = "SELECT COUNT(id) AS c FROM $tbname WHERE id='$id'";
    $rs = $connh->Execute($query);
    return $rs->fields('c');
}

//-------------------------------------------------------------------------
 // @@@ SELECTCONTENT @@@
 // accetta 3 parametri
 // contentenum (string|string|...) accetta nomi di tabelle di contenuto separate
 //     dal carettere "pipe" ( | ). Se non vengono forniti, la tendina stampa tutti
 //     i campi di contenuto disponibili
 // persistent (y|n) se impostato a y il valore selezionato viene ricordato nella sessione
 // checkusage (y|n) controlla se esiste un id corrispoindente per la tabella di contenuto in esame
 //                   se non lo trova, non la stampa (default n)
 // class classe css da abbinare al tag html select
//-------------------------------------------------------------------------
function contentadmin ($connh, $row, $PRISCILLA_SESSION, $options)
{
    if ($options[checkusage] == '') $options[checkusage] = 'y';
    if ($options[persistent] == '') $options[persistent] = 'y';

    $ret .= "<form method=\"post\" action=\"$_SERVER[PHP_SELF]\" name=\"selectcontent\" id=\"selectcontent\">";
    if ($options[persistent] == 'y') $ret .= "<input type=\"hidden\" name=\"contentselectpersist\" value=\"y\">";
    $ret .= "<select name=\"contentselected\" class=\"$options[class]\" onChange=\"document.selectcontent.submit()\">\n";

    if ($PRISCILLA_SESSION->getvalue('contentselected') != '')
    {
        $table_sel = substr($PRISCILLA_SESSION->getvalue('contentselected'), 8);
        $ret .= "<option value=\"".$PRISCILLA_SESSION->getvalue('contentselected')."\" selected>".$table_sel."\n";
    }

    $contentenum = explode("|", $options[contentenum]);
    if (count($contentenum) > 1)
    {
        foreach ($contentenum as $key=>$val)
        {
            if ($table_sel != $val && $val != $PRISCILLA_SESSION->getvalue('contentselected'))
            {
                $tbname = 'content_'.$val;
                if ($options[checkusage] == 'n' || check_content_usage($row[id], $tbname, $connh) > 0)
                    $ret .= "<OPTION value=\"$tbname\">$val</OPTION>\n";
            }
        }
    }
    else
    {
        $result = $connh->MetaTables();
        $i = 0;
        while($i < count($result))
        {
            $tbname = $result[$i];
            if (strstr($tbname, "content_"))
            {
                $table = substr($tbname, 8);
                if ($table_sel != $table)
                {
                    if ($options[checkusage] == 'n' || check_content_usage($row[id], $tbname, $connh) > 0)
                        $ret .= "<OPTION value=\"$tbname\">$table</OPTION>\n";
                }
            }
            $i++;
        }
    }

    $ret .= "</select>\n";

    return $ret;
}

?>